# This example script replicates the functionality of IronPython.2.7.9
# June 2020 : Initial release by SSI
#

import clr
import os
clr.AddReference("System.Windows.Forms")
clr.AddReference("System.Drawing")
from System.Windows.Forms import Form, Button, MessageBox, Label, CheckBox, TextBox
from System.Windows.Forms import FormBorderStyle, GroupBox, StatusBar
from System.Drawing import Point, Size

ck1 = bool(0)
ck2 = bool(0)
number = 3
ax = [1,1,1]
bx = [0,0,0]

#
class IForm(Form):
    def __init__(self):
        global ax,bx
        self.Text = os.path.basename(__file__).split(".")[0]
        self.l1 = Label()
        self.l1.Location = Point(10, 10)
        self.l1.Size = Size(250, 75)
        self.l1.Text = "Support elements and the axis as follows." + 2*"\n"
        self.l1.Text += "Line2 " + "\t" + " - Only use R" + "\n"
        self.l1.Text += "Quad4" + "\t" + " - use R and S" + "\n"
        self.l1.Text += "Wedge6" + "\t" + " - Only use T" + "\n"
        self.l1.Text += "Hexa8" + "\t" + " - use R , S and T"
        self.Controls.Add(self.l1)

        self.checkBox1 = CheckBox()
        self.checkBox1.Location = Point(10, 75)
        self.checkBox1.Size = Size(120, 14)
        self.checkBox1.Text = "HEXA8 -> QUAD8 for Shell"
#        self.Controls.Add(self.checkBox1)
        self.checkBox1.Click += self.checkBox_clicked
        self.checkBox2 = CheckBox()
        self.checkBox2.Location = Point(170, 75)
        self.checkBox2.Size = Size(150, 14)
        self.checkBox2.Text = "auto component"
#       self.Controls.Add(self.checkBox2)
        self.checkBox2.Click += self.checkBox_clicked

        y = 95
        self.l2 = Label()
        self.l2.Location = Point(10, y)
        self.l2.Size = Size(280, 14)
        self.l2.Text = "Elem. axis    No. of Division    Bias (-10 to 10)"
        self.Controls.Add(self.l2)

        y += 20
        self.lx1 = [None] * number
        self.ax1 = [None] * number
        self.bx1 = [None] * number
        for x in range(number):
            self.lx1[x] = Label()
            self.lx1[x].Location = Point(10, y)
            self.lx1[x].Size = Size(40, 14)
            self.lx1[x].Text = "R"
            self.Controls.Add(self.lx1[x])
            self.ax1[x] = TextBox()
            self.ax1[x].Location = Point(80,y)
            self.ax1[x].Width = 70
            self.ax1[x].Text = str(ax[x])
            self.ax1[x].AcceptsReturn = True
            self.ax1[x].Click += self.OnChanged
            self.Controls.Add(self.ax1[x])
            self.bx1[x] = TextBox()
            self.bx1[x].Location = Point(170,y)
            self.bx1[x].Width = 40
            self.bx1[x].Text = str(bx[x])
            self.bx1[x].Click += self.OnChanged
            self.Controls.Add(self.bx1[x])
            y += 25

        self.lx1[1].Text = "S"
        self.lx1[2].Text = "T"

        y = 205
        self.b1 = Button()
        self.b1.Text = "Close"
        self.b1.Location = Point(60, y)      
        self.Controls.Add(self.b1)
        self.b2 = Button()
        self.b2.Text = "Apply"
        self.b2.Location = Point(150, y)      
        self.Controls.Add(self.b2)
        self.b1.Click += self.button_clicked
        self.b2.Click += self.button_clicked

#        self.FormBorderStyle = FormBorderStyle.FixedToolWindow
        self.FormBorderStyle = FormBorderStyle.FixedDialog
        self.statusbar = StatusBar()
        self.statusbar.Parent = self
        self.statusbar.Text = "Ready"
        self.CenterToScreen()

    def checkBox_clicked(self, sender, e):
        global ck1,ck2
        mw.message(sender.Text + "," +  str(sender.Checked))
        if self.checkBox1.Checked: ck1 = bool(1)
        else: ck1 = bool(0)
        if self.checkBox2.Checked: ck2 = bool(1)
        else: ck2 = bool(0)

    def OnChanged(self, sender, event):
        global ax,bx

    def button_clicked(self, sender, event):
        if sender.Text == "Apply":
            self.statusbar.Text = "Refinning ..."
            ax[0] = int(self.ax1[0].Text)
            ax[1] = int(self.ax1[1].Text)
            ax[2] = int(self.ax1[2].Text)
            bx[0] = int(self.bx1[0].Text)
            bx[1] = int(self.bx1[1].Text)
            bx[2] = int(self.bx1[2].Text)
            Mains()
            self.statusbar.Text = "Ready"
        else:
            Form.Close(f)

#
def Mains():
    global ax,bx,ck1,ck2
 
    ex = mw.selected_elements()
    if len(ex) == 0: ex = mw.all_elements()

#    s = ""
#    for n in ex:
#      s = s + str(n) + " "
#    mw.message(s)
#    s = "ax: " + str(ax[0]) + " , " + str(ax[1]) + " , "+ str(ax[2]) + "\n"
#    s += "bx: " + str(bx[0]) + " , " + str(bx[1]) + " , "+ str(bx[2]) + "\n"
#    mw.message(s)
    exs = []
    ext = []
    exx = []
    edr = []
    eds = []
    edt = []
    b1x = []
    b1y = []
    b1z = []
    b2x = []
    b2y = []
    b2z = []
    b3x = []
    b3y = []
    b3z = []
    b4x = []
    b4y = []
    b4z = []
    nc = 0

    for ed in ex:
      nn = mw.nodes(ed)
#      s = ""
#      for n in nn:
#        s = s + str(n) + " "
#      mw.message(str(ed) + " : " + s)
      ee = len(mw.nodes(ed))
      if ee == 0: break
      elif ee == 2:               # LINE2
        b1x = Bias(mw.node(nn[1]).x,mw.node(nn[0]).x,ax[0],bx[0])
        b1y = Bias(mw.node(nn[1]).y,mw.node(nn[0]).y,ax[0],bx[0])
        b1z = Bias(mw.node(nn[1]).z,mw.node(nn[0]).z,ax[0],bx[0])
        r0 = [mw.node(nn[0]).x,mw.node(nn[0]).y,mw.node(nn[0]).z]
        r1 = [mw.node(nn[1]).x,mw.node(nn[1]).y,mw.node(nn[1]).z]
        n0 = nn[0]
        for i in range(ax[0]):
          if ax[0] <= 1: break
          if i == ax[0]-1:
            n1 = nn[1]
          else:
            r0[0] += b1x[i]
            r0[1] += b1y[i]
            r0[2] += b1z[i]
            n1 = mw.new_node(Vector(r0[0],r0[1],r0[2]))
            nc += 1
          nx = [n0,n1]
          e1 = mw.new_element("line2",nx,component=None)
          exs.append(e1)
          if i == 0: edr.append(ed)
          n0 = n1
      elif ee == 3: pass          # LINE3
      elif ee == 4:               # QUAD4
        b1x = Bias(mw.node(nn[1]).x,mw.node(nn[0]).x,ax[0],bx[0])
        b1y = Bias(mw.node(nn[1]).y,mw.node(nn[0]).y,ax[0],bx[0])
        b1z = Bias(mw.node(nn[1]).z,mw.node(nn[0]).z,ax[0],bx[0])
        b2x = Bias(mw.node(nn[2]).x,mw.node(nn[3]).x,ax[0],bx[0])
        b2y = Bias(mw.node(nn[2]).y,mw.node(nn[3]).y,ax[0],bx[0])
        b2z = Bias(mw.node(nn[2]).z,mw.node(nn[3]).z,ax[0],bx[0])
        r0 = [mw.node(nn[0]).x,mw.node(nn[0]).y,mw.node(nn[0]).z]
        r3 = [mw.node(nn[3]).x,mw.node(nn[3]).y,mw.node(nn[3]).z]
        n0 = nn[0]
        n3 = nn[3]
        for i in range(ax[0]):
          if i == ax[0]-1:
            n1 = nn[1]
            n2 = nn[2]
          else:
            r0[0] += b1x[i]
            r0[1] += b1y[i]
            r0[2] += b1z[i]
            n1 = mw.new_node(Vector(r0[0],r0[1],r0[2]))
            r3[0] += b2x[i]
            r3[1] += b2y[i]
            r3[2] += b2z[i]
            n2 = mw.new_node(Vector(r3[0],r3[1],r3[2]))
            nc += 2
          nx = [n0,n1,n2,n3]
          e1 = mw.new_element("quad4",nx,component=None)
          exs.append(e1)
          if i == 0: edr.append(ed)
          n0 = n1
          n3 = n2 
      elif ee == 6:            # WEDGE6
        b1x = Bias(mw.node(nn[3]).x,mw.node(nn[0]).x,ax[2],bx[2])
        b1y = Bias(mw.node(nn[3]).y,mw.node(nn[0]).y,ax[2],bx[2])
        b1z = Bias(mw.node(nn[3]).z,mw.node(nn[0]).z,ax[2],bx[2])
        b2x = Bias(mw.node(nn[4]).x,mw.node(nn[1]).x,ax[2],bx[2])
        b2y = Bias(mw.node(nn[4]).y,mw.node(nn[1]).y,ax[2],bx[2])
        b2z = Bias(mw.node(nn[4]).z,mw.node(nn[1]).z,ax[2],bx[2])
        b3x = Bias(mw.node(nn[5]).x,mw.node(nn[2]).x,ax[2],bx[2])
        b3y = Bias(mw.node(nn[5]).y,mw.node(nn[2]).y,ax[2],bx[2])
        b3z = Bias(mw.node(nn[5]).z,mw.node(nn[2]).z,ax[2],bx[2])
        r0 = [mw.node(nn[0]).x,mw.node(nn[0]).y,mw.node(nn[0]).z]
        r1 = [mw.node(nn[1]).x,mw.node(nn[1]).y,mw.node(nn[1]).z]
        r2 = [mw.node(nn[2]).x,mw.node(nn[2]).y,mw.node(nn[2]).z]
        n0 = nn[0]
        n1 = nn[1]
        n2 = nn[2]
        for i in range(ax[2]):
          if i == ax[2]-1:
            n3 = nn[3]
            n4 = nn[4]
            n5 = nn[5]
          else:
            r0[0] += b1x[i]
            r0[1] += b1y[i]
            r0[2] += b1z[i]
            n3 = mw.new_node(Vector(r0[0],r0[1],r0[2]))
            r1[0] += b2x[i]
            r1[1] += b2y[i]
            r1[2] += b2z[i]
            n4 = mw.new_node(Vector(r1[0],r1[1],r1[2]))
            r2[0] += b3x[i]
            r2[1] += b3y[i]
            r2[2] += b3z[i]
            n5 = mw.new_node(Vector(r2[0],r2[1],r2[2]))
            nc += 3
          nx = [n0,n1,n2,n3,n4,n5]
          e1 = mw.new_element("wedge6",nx,component=None)
          exs.append(e1)
          if i == 0: edr.append(ed)
          n0 = n3
          n1 = n4
          n2 = n5
      elif ee == 8:               # HEXA8, QUAD8
        b1x = Bias(mw.node(nn[1]).x,mw.node(nn[0]).x,ax[0],bx[0])
        b1y = Bias(mw.node(nn[1]).y,mw.node(nn[0]).y,ax[0],bx[0])
        b1z = Bias(mw.node(nn[1]).z,mw.node(nn[0]).z,ax[0],bx[0])
        b2x = Bias(mw.node(nn[2]).x,mw.node(nn[3]).x,ax[0],bx[0])
        b2y = Bias(mw.node(nn[2]).y,mw.node(nn[3]).y,ax[0],bx[0])
        b2z = Bias(mw.node(nn[2]).z,mw.node(nn[3]).z,ax[0],bx[0])
        b3x = Bias(mw.node(nn[5]).x,mw.node(nn[4]).x,ax[0],bx[0])
        b3y = Bias(mw.node(nn[5]).y,mw.node(nn[4]).y,ax[0],bx[0])
        b3z = Bias(mw.node(nn[5]).z,mw.node(nn[4]).z,ax[0],bx[0])
        b4x = Bias(mw.node(nn[6]).x,mw.node(nn[7]).x,ax[0],bx[0])
        b4y = Bias(mw.node(nn[6]).y,mw.node(nn[7]).y,ax[0],bx[0])
        b4z = Bias(mw.node(nn[6]).z,mw.node(nn[7]).z,ax[0],bx[0])
        r0 = [mw.node(nn[0]).x,mw.node(nn[0]).y,mw.node(nn[0]).z]
        r3 = [mw.node(nn[3]).x,mw.node(nn[3]).y,mw.node(nn[3]).z]
        r4 = [mw.node(nn[4]).x,mw.node(nn[4]).y,mw.node(nn[4]).z]
        r7 = [mw.node(nn[7]).x,mw.node(nn[7]).y,mw.node(nn[7]).z]
        n0 = nn[0]
        n3 = nn[3]
        n4 = nn[4]
        n7 = nn[7]
        for i in range(ax[0]):
          if i == ax[0]-1:
            n1 = nn[1]
            n2 = nn[2]
            n5 = nn[5]
            n6 = nn[6]
          else:
            r0[0] += b1x[i]
            r0[1] += b1y[i]
            r0[2] += b1z[i]
            n1 = mw.new_node(Vector(r0[0],r0[1],r0[2]))
            r3[0] += b2x[i]
            r3[1] += b2y[i]
            r3[2] += b2z[i]
            n2 = mw.new_node(Vector(r3[0],r3[1],r3[2]))
            r4[0] += b3x[i]
            r4[1] += b3y[i]
            r4[2] += b3z[i]
            n5 = mw.new_node(Vector(r4[0],r4[1],r4[2]))
            r7[0] += b4x[i]
            r7[1] += b4y[i]
            r7[2] += b4z[i]
            n6 = mw.new_node(Vector(r7[0],r7[1],r7[2]))
            nc += 4
          nx = [n0,n1,n2,n3,n4,n5,n6,n7]
          e1 = mw.new_element("hex8",nx,component=None)
          exs.append(e1)
          if i == 0: edr.append(ed)
          n0 = n1
          n3 = n2
          n4 = n5
          n7 = n6
      elif ee == 15: pass         # WEDGE15
      elif ee == 20: pass         # HEX20

    for ed in exs:
      nn = mw.nodes(ed)
      ee = len(mw.nodes(ed))
      if ee == 0: break
      if ee == 2: pass            # LINE2
      elif ee == 3: pass          # LINE3
      elif ee == 4:               # QUAD4
        b1x = Bias(mw.node(nn[2]).x,mw.node(nn[1]).x,ax[1],bx[1])
        b1y = Bias(mw.node(nn[2]).y,mw.node(nn[1]).y,ax[1],bx[1])
        b1z = Bias(mw.node(nn[2]).z,mw.node(nn[1]).z,ax[1],bx[1])
        b2x = Bias(mw.node(nn[3]).x,mw.node(nn[0]).x,ax[1],bx[1])
        b2y = Bias(mw.node(nn[3]).y,mw.node(nn[0]).y,ax[1],bx[1])
        b2z = Bias(mw.node(nn[3]).z,mw.node(nn[0]).z,ax[1],bx[1])
        r0 = [mw.node(nn[0]).x,mw.node(nn[0]).y,mw.node(nn[0]).z]
        r1 = [mw.node(nn[1]).x,mw.node(nn[1]).y,mw.node(nn[1]).z]
        n0 = nn[0]
        n1 = nn[1]
        for j in range(ax[1]):
          if ax[1] < 1: break
          if j == ax[1]-1:
            n2 = nn[2]
            n3 = nn[3]
          else:
            r1[0] += b1x[j]
            r1[1] += b1y[j]
            r1[2] += b1z[j]
            n2 = mw.new_node(Vector(r1[0],r1[1],r1[2]))
            r0[0] += b2x[j]
            r0[1] += b2y[j]
            r0[2] += b2z[j]
            n3 = mw.new_node(Vector(r0[0],r0[1],r0[2]))
            nc += 2
          ny = [n0,n1,n2,n3]
          e2 = mw.new_element("quad4",ny,component=None)
          if j == 0: eds.append(ed)
          n0 = n3
          n1 = n2
      elif ee == 6: pass          # WEDGE6
      elif ee == 8:               # HEXA8, QUAD8
        b1x = Bias(mw.node(nn[2]).x,mw.node(nn[1]).x,ax[1],bx[1])
        b1y = Bias(mw.node(nn[2]).y,mw.node(nn[1]).y,ax[1],bx[1])
        b1z = Bias(mw.node(nn[2]).z,mw.node(nn[1]).z,ax[1],bx[1])
        b2x = Bias(mw.node(nn[3]).x,mw.node(nn[0]).x,ax[1],bx[1])
        b2y = Bias(mw.node(nn[3]).y,mw.node(nn[0]).y,ax[1],bx[1])
        b2z = Bias(mw.node(nn[3]).z,mw.node(nn[0]).z,ax[1],bx[1])
        b3x = Bias(mw.node(nn[6]).x,mw.node(nn[5]).x,ax[1],bx[1])
        b3y = Bias(mw.node(nn[6]).y,mw.node(nn[5]).y,ax[1],bx[1])
        b3z = Bias(mw.node(nn[6]).z,mw.node(nn[5]).z,ax[1],bx[1])
        b4x = Bias(mw.node(nn[7]).x,mw.node(nn[4]).x,ax[1],bx[1])
        b4y = Bias(mw.node(nn[7]).y,mw.node(nn[4]).y,ax[1],bx[1])
        b4z = Bias(mw.node(nn[7]).z,mw.node(nn[4]).z,ax[1],bx[1])
        r0 = [mw.node(nn[0]).x,mw.node(nn[0]).y,mw.node(nn[0]).z]
        r1 = [mw.node(nn[1]).x,mw.node(nn[1]).y,mw.node(nn[1]).z]
        r4 = [mw.node(nn[4]).x,mw.node(nn[4]).y,mw.node(nn[4]).z]
        r5 = [mw.node(nn[5]).x,mw.node(nn[5]).y,mw.node(nn[5]).z]
        n0 = nn[0]
        n1 = nn[1]
        n4 = nn[4]
        n5 = nn[5]
        for j in range(ax[1]):
          if ax[1] < 1: break
          if j == ax[1]-1:
            n2 = nn[2]
            n3 = nn[3]
            n6 = nn[6]
            n7 = nn[7]
          else:
            r0[0] += b2x[j]
            r0[1] += b2y[j]
            r0[2] += b2z[j]
            n3 = mw.new_node(Vector(r0[0],r0[1],r0[2]))
            r1[0] += b1x[j]
            r1[1] += b1y[j]
            r1[2] += b1z[j]
            n2 = mw.new_node(Vector(r1[0],r1[1],r1[2]))
            r4[0] += b4x[j]
            r4[1] += b4y[j]
            r4[2] += b4z[j]
            n7 = mw.new_node(Vector(r4[0],r4[1],r4[2]))
            r5[0] += b3x[j]
            r5[1] += b3y[j]
            r5[2] += b3z[j]
            n6 = mw.new_node(Vector(r5[0],r5[1],r5[2]))
            nc += 4
          ny = [n0,n1,n2,n3,n4,n5,n6,n7]
          e2 = mw.new_element("hex8",ny,component=None)
          ext.append(e2)
          if j == 0: eds.append(ed)
          n0 = n3
          n1 = n2
          n4 = n7
          n5 = n6
      elif ee == 15: pass         # WEDGE15
      elif ee == 20: pass         # HEX20

    for ed in ext:
      nn = mw.nodes(ed)
      ee = len(mw.nodes(ed))
      if ee == 0: break
      if ee == 2: pass            # LINE2
      elif ee == 3: pass          # LINE3
      elif ee == 4: pass          # QUAD4
      elif ee == 6: pass          # WEDGE6
      elif ee == 8:               # HEXA8, QUAD8
        b1x = Bias(mw.node(nn[4]).x,mw.node(nn[0]).x,ax[2],bx[2])
        b1y = Bias(mw.node(nn[4]).y,mw.node(nn[0]).y,ax[2],bx[2])
        b1z = Bias(mw.node(nn[4]).z,mw.node(nn[0]).z,ax[2],bx[2])
        b2x = Bias(mw.node(nn[5]).x,mw.node(nn[1]).x,ax[2],bx[2])
        b2y = Bias(mw.node(nn[5]).y,mw.node(nn[1]).y,ax[2],bx[2])
        b2z = Bias(mw.node(nn[5]).z,mw.node(nn[1]).z,ax[2],bx[2])
        b3x = Bias(mw.node(nn[6]).x,mw.node(nn[2]).x,ax[2],bx[2])
        b3y = Bias(mw.node(nn[6]).y,mw.node(nn[2]).y,ax[2],bx[2])
        b3z = Bias(mw.node(nn[6]).z,mw.node(nn[2]).z,ax[2],bx[2])
        b4x = Bias(mw.node(nn[7]).x,mw.node(nn[3]).x,ax[2],bx[2])
        b4y = Bias(mw.node(nn[7]).y,mw.node(nn[3]).y,ax[2],bx[2])
        b4z = Bias(mw.node(nn[7]).z,mw.node(nn[3]).z,ax[2],bx[2])
        r0 = [mw.node(nn[0]).x,mw.node(nn[0]).y,mw.node(nn[0]).z]
        r1 = [mw.node(nn[1]).x,mw.node(nn[1]).y,mw.node(nn[1]).z]
        r2 = [mw.node(nn[2]).x,mw.node(nn[2]).y,mw.node(nn[2]).z]
        r3 = [mw.node(nn[3]).x,mw.node(nn[3]).y,mw.node(nn[3]).z]
        n0 = nn[0]
        n1 = nn[1]
        n2 = nn[2]
        n3 = nn[3]
        for k in range(ax[2]):
          if ax[2] <= 1: break
          if k == ax[2]-1:
            n4 = nn[4]
            n5 = nn[5]
            n6 = nn[6]
            n7 = nn[7]
          else:
            r0[0] += b1x[k]
            r0[1] += b1y[k]
            r0[2] += b1z[k] 
            n4 = mw.new_node(Vector(r0[0],r0[1],r0[2]))
            r1[0] += b2x[k]
            r1[1] += b2y[k]
            r1[2] += b2z[k]
            n5 = mw.new_node(Vector(r1[0],r1[1],r1[2]))
            r2[0] += b3x[k]
            r2[1] += b3y[k]
            r2[2] += b3z[k] 
            n6 = mw.new_node(Vector(r2[0],r2[1],r2[2]))
            r3[0] += b4x[k]
            r3[1] += b4y[k]
            r3[2] += b4z[k]
            n7 = mw.new_node(Vector(r3[0],r3[1],r3[2]))
            nc += 4
          nz = [n0,n1,n2,n3,n4,n5,n6,n7]
          e3 = mw.new_element("hex8",nz,component=None)
          exx.append(e3)
          if k == 0: edt.append(ed)
          n0 = n4
          n1 = n5
          n2 = n6
          n3 = n7
      elif ee == 15: pass         # WEDGE15
      elif ee == 20: pass         # HEX20

    mw.set_model_active()
    mw.display()

    if len(edr) > 0: mw.delete_elements(edr)
    if len(eds) > 0: mw.delete_elements(eds)
    if len(edt) > 0: mw.delete_elements(edt)
#
def Bias(mx,mi,fn,bs):
#  mw.message("Bias : " + str(mx) + " , " + str(mi)  + " , " + str(fn) + " , " + str(bs))
  fx = []
  fs = mx - mi
  f1 = fs / fn
  f2 = 0.
  fr = 1
  if fs * bs <> 0: fr = 1 + 0.1 * f1 / fs * bs
  s1 = "ratio1 : "
  s2 = "total1 : "
  for i in range(fn):
    f1 = f1*fr**i
    f2 += f1
    s1 = s1 + str(f1) + " , "
    s2 = s2 + str(f2) + " , "

  f1 = fs / fn
  f3 = 0
  if f2 <> 0: f3 = fs / f2
  f5 = 0
  s3 = "ratio2 : "
  s4 = "total2 : "
  for i in range(fn):
    f1 = f1*fr**i
    f2 += f1
    f4 = f1*f3
    f5 += f4
    fx.append(f4)
    s3 = s3 + str(f4) + " , "
    s4 = s4 + str(f5) + " , "

#  mw.message(s1 + "\n" + s2 + "\n" + s3 + "\n" + s4)
  return fx

#

f = IForm()
Form.ShowDialog(f)

