# This example script replicates the functionality of
#
#           Mesh tools -> Transfer displacements from solution
#

import clr
import System
import os, sys
clr.AddReference("System.Windows.Forms")
clr.AddReference("System.Drawing")
from System.Windows.Forms import Application, Form, ListBox, Label, TextBox, CheckBox
from System.Windows.Forms import Button, MessageBox, FormBorderStyle, GroupBox, StatusBar
from System.Drawing import Point, Size

#
class IForm(Form):
    def __init__(self):
        self.Text = os.path.basename(__file__).split(".")[0]

        self.label1 = Label()
        self.label1.Location = Point(10, 10)
        self.label1.Size = Size(180, 14)
        self.label1.Text = "Transfer displacements"
        self.Controls.Add(self.label1)

        self.ListBox1 = ListBox()
        self.ListBox1.Location = Point(10,28)
        self.ListBox1.Name = "comboBox1"
        self.ListBox1.Size = Size(180,80)
        self.ListBox1.DataSource = source
        self.ListBox1.TabIndex = 0
        self.Controls.Add(self.ListBox1)
        self.ListBox1.SelectedIndexChanged += self.ListBox1SelectedIndexChanged

        self.checkBox1 = CheckBox()
        self.checkBox1.Text = "Apply on"
        self.checkBox1.Click += self.checkBox_clicked
        self.checkBox1.Location = Point(10,110)
        self.Controls.Add(self.checkBox1)

        self.label2 = Label()
        self.label2.Location = Point(10, 140)
        self.label2.Size = Size(180, 14)
        self.label2.Text = "Deformation scale factor"
        self.Controls.Add(self.label2)

        self.rx3 = TextBox()
        self.rx3.Location = Point(10,160)
        self.rx3.Width = 100
        self.rx3.Text = "1.0"
        self.Controls.Add(self.rx3)

        self.b1 = Button()
        self.b1.Text = 'Reset'
        self.b2 = Button()
        self.b2.Text = 'Apply'
        self.b1.Location = Point(20,195)
        self.b2.Location = Point(30+self.b1.Width,195)
        self.Controls.Add(self.b1)
        self.Controls.Add(self.b2)

        self.b1.Click += self.button_clicked
        self.b2.Click += self.button_clicked

        self.ClientSize = Size(200, 250)
        self.CenterToScreen()
#
        self.FormBorderStyle = FormBorderStyle.FixedDialog
        self.statusbar = StatusBar()
        self.statusbar.Parent = self
        self.statusbar.Text = "Ready"

    def ListBox1SelectedIndexChanged(self, sender, e):
        global mn, sn, ck1, r3
        sss = sender.Text
        mn = sn[sender.SelectedIndex]
        if ck1:
            r3 = float(self.rx3.Text)
            Mains()
#
    def checkBox_clicked(self, sender, e):
        global ck1
        if self.checkBox1.Checked: ck1 = bool(1)
        else: ck1 = bool(0)
#
    def button_clicked(self, sender, event):
        global r3, rsw
        if sender.Text == "Apply":
            self.statusbar.Text = "Transfer ..."
            r3 = float(self.rx3.Text)
            Mains()
        elif sender.Text == "Reset":
            rsw = bool(1)
            self.statusbar.Text = "Reset ..."
            Mains()
        else:
            Form.Close(f)
        rsw = bool(0)
        self.statusbar.Text = "Ready"
#
def Mains():
  if rsw:
    for node_id in mw.all_nodes():
      mw.set_node_x(node_id, lsx[node_id])
      mw.set_node_y(node_id, lsy[node_id])
      mw.set_node_z(node_id, lsz[node_id])
  elif stype == 2: # solution.mode
    for node_id in mw.all_nodes(): # mw.all_nodes(): solution.all_nodes():
      displacement_x = solution.node_value("displx", node_id, mode=mn)
      displacement_y = solution.node_value("disply", node_id, mode=mn)
      displacement_z = solution.node_value("displz", node_id, mode=mn)
      new_x = lsx[node_id] + displacement_x * r3
      new_y = lsy[node_id] + displacement_y * r3
      new_z = lsz[node_id] + displacement_z * r3
      mw.set_node_x(node_id, new_x)
      mw.set_node_y(node_id, new_y)
      mw.set_node_z(node_id, new_z)
  elif stype == 3: # solution.time_step
    for node_id in mw.all_nodes():
      displacement_x = solution.node_value("displx", node_id, time_step=mn)
      displacement_y = solution.node_value("disply", node_id, time_step=mn)
      displacement_z = solution.node_value("displz", node_id, time_step=mn)
      new_x = lsx[node_id] + displacement_x * r3
      new_y = lsy[node_id] + displacement_y * r3
      new_z = lsz[node_id] + displacement_z * r3
      mw.set_node_x(node_id, new_x)
      mw.set_node_y(node_id, new_y)
      mw.set_node_z(node_id, new_z)
  else: # solution.displacement
    for node_id in mw.all_nodes():
      displacement_x = solution.node_value("displx", node_id)
      displacement_y = solution.node_value("disply", node_id)
      displacement_z = solution.node_value("displz", node_id)
      new_x = lsx[node_id] + displacement_x * r3
      new_y = lsy[node_id] + displacement_y * r3
      new_z = lsz[node_id] + displacement_z * r3
      mw.set_node_x(node_id, new_x)
      mw.set_node_y(node_id, new_y)
      mw.set_node_z(node_id, new_z)
#
  mw.set_model_active()
  mw.display()

# Main program  

stype = 1
r3 = 1.0
mn = 1
source = []
sn = []
lsx = [0.0]
lsy = [0.0]
lsz = [0.0]
rsw = bool(0)
ck1 = bool(0)

for node_id in mw.all_nodes():
  lsx.append(mw.node(node_id).x)
  lsy.append(mw.node(node_id).y)
  lsz.append(mw.node(node_id).z)

if len(solution.modes()) > 0:
  stype = 2
  for i in solution.modes():
    sn.append(i)
    source.append("Mode " + str(i))
    mn = sn[0]
elif len(solution.time_steps()) > 0:
  stype = 3
  for i in solution.time_steps():
    sn.append(i) 
    source.append("Time step " + str(i))
    mn = sn[0]
else:
  sn.append(1)
  source.append("Displacement")

f = IForm()
Form.ShowDialog(f)