# This example script replicates the functionality of IronPython.2.7.9
# June 2020     : Initial release
# December 2020 : Expand CCX Solver Result for Shell
#

svs = ["Meter (newton)","Foot (poundf)","Meter (kilogram f)","Foot (poundal)","mm (milli newton)"]
svs = svs + ["cm (centi newton)","Inch (pound f)","mm (kilogram f)","USER_DEFINED"]
sss = svs[0]

sn = 0
ck1 = bool(0)
ck2 = bool(0)
ck3 = bool(0)
ck4 = bool(0)
ck5 = bool(0)
ck6 = bool(0)
ck21 = bool(1)
ck22 = bool(0)
ck23 = bool(0)
ck24 = bool(0)
edn = 0
ndn = 0
s3 = ""
s4 = ""
s5 = ""
s6 = ""
s9 = ""
loadid = 0
loadid2 = 0
loadid3 = 0
loadid4 = 0
#
import clr
import System
import os, sys
clr.AddReference("System.Windows.Forms")
clr.AddReference("System.Drawing")
from System.Windows.Forms import Application, Form, ComboBox, Label, CheckBox
from System.Windows.Forms import Button, MessageBox, FormBorderStyle, GroupBox, StatusBar
from System.Drawing import Point, Size, Color

#
class IForm(Form):
    def __init__(self):
        self.Text = os.path.basename(__file__).split(".")[0]

        self.label1 = Label()
        self.label1.Location = Point(10, 10)
        self.label1.Size = Size(180, 14)
        self.label1.Text = "UNIT LABEL Selection"
        self.Controls.Add(self.label1)

        self.comboBox1 = ComboBox()
        self.comboBox1.Location = Point(10,28)
        self.comboBox1.Name = "comboBox1"
        self.comboBox1.Size = Size(180, 24)
        self.comboBox1.DataSource = svs
        self.comboBox1.TabIndex = 0

        self.checkBox1 = CheckBox()
        self.checkBox2 = CheckBox()
        self.checkBox3 = CheckBox()
        self.checkBox4 = CheckBox()
        self.checkBox5 = CheckBox()
        self.checkBox5 = CheckBox()
        self.checkBox6 = CheckBox()

        self.groupBox1 = GroupBox()
        self.groupBox1.Controls.Add(self.checkBox1)
        self.groupBox1.Controls.Add(self.checkBox2)
        self.groupBox1.Controls.Add(self.checkBox3)
        self.groupBox1.Controls.Add(self.checkBox4)
        self.groupBox1.Controls.Add(self.checkBox5)
        self.groupBox1.Controls.Add(self.checkBox6)
        self.groupBox1.Location = Point(10, 55)
        self.groupBox1.Size = Size(180, 145)
        self.groupBox1.Text = "Element Convert Option"
        self.Controls.Add(self.groupBox1)

        self.checkBox21 = CheckBox()
        self.checkBox22 = CheckBox()
        self.checkBox23 = CheckBox()
        self.checkBox24 = CheckBox()

        self.groupBox2 = GroupBox()
        self.groupBox2.Controls.Add(self.checkBox21)
        self.groupBox2.Controls.Add(self.checkBox22)
        self.groupBox2.Controls.Add(self.checkBox23)
        self.groupBox2.Controls.Add(self.checkBox24)
        self.groupBox2.Location = Point(10,205)
        self.groupBox2.Size = Size(180, 120)
        self.groupBox2.Text = "Analisys Covert Option"
        self.Controls.Add(self.groupBox2)

        self.ClientSize = Size(200, 380)
        self.Controls.Add(self.comboBox1)

        self.comboBox1.SelectedIndexChanged += self.ComboBox1SelectedIndexChanged

        self.b1 = Button()
        self.b1.Text = 'Close'
        self.b2 = Button()
        self.b2.Text = 'Export'
        self.b1.Location = Point(20,330)
        self.b2.Location = Point(30+self.b1.Width,330)
        self.Controls.Add(self.b1)
        self.Controls.Add(self.b2)

        self.b1.Click += self.button_clicked
        self.b2.Click += self.button_clicked

        self.checkBox1.Location = Point(10, 20)
        self.checkBox2.Location = Point(10, 40)
        self.checkBox3.Location = Point(10, 60)
        self.checkBox4.Location = Point(10, 80)
        self.checkBox5.Location = Point(10, 100)
        self.checkBox6.Location = Point(10, 120)

        self.checkBox1.Size = Size(160, 20)
        self.checkBox2.Size = Size(160, 20)
        self.checkBox3.Size = Size(160, 20)
        self.checkBox4.Size = Size(160, 20)
        self.checkBox5.Size = Size(160, 20)
        self.checkBox6.Size = Size(160, 20)
        self.checkBox1.Text = "QUAD4 -> TETR4 (Solid)"
        self.checkBox2.Text = "PYR5/13 -> 2*TETR4/10"
        self.checkBox3.Text = "TRIA3 -> LINE3"
        self.checkBox4.Text = "PENT6 -> TRIA6 (Shell)"
        self.checkBox5.Text = "HEXA8 -> QUAD8 (Shell)"
        self.checkBox6.Text = "Result Model (for CCX)"

        self.checkBox1.Click += self.checkBox_clicked
        self.checkBox2.Click += self.checkBox_clicked
        self.checkBox3.Click += self.checkBox_clicked
        self.checkBox4.Click += self.checkBox_clicked
        self.checkBox5.Click += self.checkBox_clicked
        self.checkBox6.Click += self.checkBox_clicked

        self.checkBox21.Location = Point(10, 20)
        self.checkBox22.Location = Point(10, 40)
        self.checkBox23.Location = Point(10, 60)
        self.checkBox24.Location = Point(10, 80)
        self.checkBox21.Size = Size(160, 20)
        self.checkBox22.Size = Size(160, 20)
        self.checkBox23.Size = Size(160, 20)
        self.checkBox24.Size = Size(160, 20)
        self.checkBox21.Text = "Displacement data"
        self.checkBox22.Text = "Stress data"
        self.checkBox23.Text = "Strain data"
        self.checkBox21.Checked = ck21
        self.checkBox24.Text = "VonMises stress ..."
        self.checkBox21.Click += self.checkBox_clicked
        self.checkBox22.Click += self.checkBox_clicked
        self.checkBox23.Click += self.checkBox_clicked
        self.checkBox24.Click += self.checkBox_clicked

#        self.FormBorderStyle = FormBorderStyle.FixedToolWindow
        self.FormBorderStyle = FormBorderStyle.FixedDialog
        self.statusbar = StatusBar()
        self.statusbar.Parent = self
        self.statusbar.Text = "Ready"
        self.CenterToScreen()
#
    def ComboBox1SelectedIndexChanged(self, sender, e):
        global sn, sss
        sss = sender.Text
        sn = sender.SelectedIndex

    def checkBox_clicked(self, sender, e):
        global ck1, ck2, ck3, ck4, ck5, ck6, ck21, ck22, ck23, ck24
#        mw.message(sender.Text + "," +  str(sender.Checked))
        if self.checkBox1.Checked: ck1 = bool(1)
        else: ck1 = bool(0)
        if self.checkBox2.Checked: ck2 = bool(1)
        else: ck2 = bool(0)
        if self.checkBox3.Checked: ck3 = bool(1)
        else: ck3 = bool(0)
        if self.checkBox4.Checked: ck4 = bool(1)
        else: ck4 = bool(0)
        if self.checkBox5.Checked: ck5 = bool(1)
        else: ck5 = bool(0)
        if self.checkBox6.Checked: ck6 = bool(1)
        else: ck6 = bool(0)
        if self.checkBox21.Checked: ck21 = bool(1)
        else: ck21 = bool(0)
        if self.checkBox22.Checked: ck22 = bool(1)
        else: ck22 = bool(0)
        if self.checkBox23.Checked: ck23 = bool(1)
        else: ck23 = bool(0)
        if self.checkBox24.Checked: ck24 = bool(1)
        else: ck24 = bool(0)
#
    def button_clicked(self, sender, event):
        if sender.Text == "Export":
            self.statusbar.Text = "Converting ..."
            df_color = self.BackColor
            self.BackColor = Color.FromArgb(192, 255, 192)
            Mains()
            self.statusbar.Text = "Ready"
            self.BackColor = df_color
        else:
            Form.Close(f)
#
def Mains():
  global edn,ndn,s3,s4,s5,s6,s9,loadid,loadid2,loadid3,loadid4
  from System.Windows.Forms import SaveFileDialog
  from System.Windows.Forms import DialogResult
  from System.Windows.Forms import MessageBox
  filename = ""
  fdialog = SaveFileDialog()
  fdialog.Filter = "text file (*.unv)|*.unv|text file (*.uff)|*.uff|All files (*.*)|*.*"
  fdialog.FilterIndex = 1
  fdialog.RestoreDirectory = True
  if fdialog.ShowDialog() == DialogResult.OK:
    filename = fdialog.FileName
  else:
    MessageBox.Show("Please output proper filename.","Error Dialog")
    sys.exit(1)

#Timer
  import time
  start = time.clock()
  s4 = ""
  s6 = ""
  s1 = "    -1" + "\n" + "   164" + "\n"
  s1 += '{:>10d}'.format(sn+1) + '{:>20s}'.format(sss) + '{:>10d}'.format(2) + "\n"
  for i in range(1,4):
    s1 += '{:25.16E}'.format(1.)
  s1 += "\n" +'{:25.16E}'.format(0.) + "\n"
  s1 += "    -1" + "\n"
  s1 += "    -1" + "\n" + "  2411" + "\n"

  if ck6:
    for nn in solution.all_nodes():
      # Read node
      s1 += '{:>10d}'.format(nn)
      s1 += '{:>10d}'.format(0)
      s1 += '{:>10d}'.format(0)
      s1 += '{:>10d}'.format(1) + "\n"
      s1 += '{:25.16E}'.format(solution.node(nn).x) + '{:25.16E}'.format(solution.node(nn).y) + '{:25.16E}'.format(solution.node(nn).z) + "\n"
  else: 
    for nn in mw.all_nodes():
      # Read node
      s1 += '{:>10d}'.format(nn)
      s1 += '{:>10d}'.format(0)
      s1 += '{:>10d}'.format(0)
      s1 += '{:>10d}'.format(1) + "\n"
      s1 += '{:25.16E}'.format(mw.node(nn).x) + '{:25.16E}'.format(mw.node(nn).y) + '{:25.16E}'.format(mw.node(nn).z) + "\n"

#  s1 += "    -1" + "\n"

  s2 = "    -1" + "\n" + "  2412" + "\n"
  edn = 0
  ndn = nn
  if ck6:
   for ed in solution.all_elements():
    # Read element
    ee = len(solution.nodes(ed))
    pyr5 = bool(0)
    if ee == 2: etype = 21     # LINE2 is 11 21 22 23 31 32
    elif ee == 3: 
        if ck3: etype = 24     # LINE3
        else: etype = 91       # TRIA3
    elif ee == 4:
        if ck1: etype = 111    # TETR4
        else: etype = 94       # QUAD4
    elif ee == 5:
        if ck2:
            etype = 111        # PYR5 -> 2*TETR4
            ee = 4
            pyr5 = bool(1)
        else: etype = 111 # 161 
    elif ee == 6:
        if ck4: etype = 92     # TRIA6
        else: etype = 112      # PENT6
    elif ee == 8:
        if ck5: etype = 95     # QUAD8
        else: etype = 115      # HEXA8
    elif ee == 10: etype = 118 # TET10
    elif ee == 13:
        if ck2:
            etype = 118        # PYR13 -> 2*TETR10
            ee = 10
            pyr5 = bool(1)
        else: etype = 161 
    elif ee == 15: etype = 113 # PEN15
    elif ee == 20: etype = 116 # HEX20
    else: etype = 161          # (lumped mass)
    s2 += '{:>10d}'.format(ed+edn)
    s2 += '{:>10d}'.format(etype)
    s2 += '{:>10d}'.format(0)
    s2 += '{:>10d}'.format(0)
    s2 += '{:>10d}'.format(0)
    s2 += '{:>10d}'.format(ee) + "\n"
    if etype == 21 or etype == 24: # for beam
      s2 += '{:>10d}'.format(0)
      s2 += '{:>10d}'.format(0)
      s2 += '{:>10d}'.format(0) + "\n"
    if pyr5 or etype == 116 or etype == 118 or etype == 113: 
      s2 += elem10(ed,etype)
    else:
      i = 0  
      for en in solution.nodes(ed):
        s2 += '{:>10}'.format(en)
        i += 1
        if i % 8 == 0: s2 += "\n"
      if i % 8 <> 0:
        s2 += "\n"  
  else:
   for ed in mw.all_elements():
    # Read element
    ee = len(mw.nodes(ed))
    pyr5 = bool(0)
    if ee == 2: etype = 21     # LINE2 is 11 21 22 23 31 32
    elif ee == 3: 
        if ck3: etype = 24     # LINE3
        else: etype = 91       # TRIA3
    elif ee == 4:
        if ck1: etype = 111    # TETR4
        else: etype = 94       # QUAD4
    elif ee == 5:
        if ck2:
            etype = 111        # PYR5 -> 2*TETR4
            ee = 4
            pyr5 = bool(1)
        else: etype = 111 # 161 
    elif ee == 6:
        if ck4: etype = 92     # TRIA6
        else: etype = 112      # PENT6
    elif ee == 8:
        if ck5: etype = 95     # QUAD8
        else: etype = 115      # HEXA8
    elif ee == 10: etype = 118 # TET10
    elif ee == 13:
        if ck2:
            etype = 118        # PYR13 -> 2*TETR10
            ee = 10
            pyr5 = bool(1)
        else: etype = 161 
    elif ee == 15: etype = 113 # PEN15
    elif ee == 20: etype = 116 # HEX20
    else: etype = 161          # (lumped mass)
    s2 += '{:>10d}'.format(ed+edn)
    s2 += '{:>10d}'.format(etype)
    s2 += '{:>10d}'.format(0)
    s2 += '{:>10d}'.format(0)
    s2 += '{:>10d}'.format(0)
    s2 += '{:>10d}'.format(ee) + "\n"
    if etype == 21 or etype == 24: # for beam
      s2 += '{:>10d}'.format(0)
      s2 += '{:>10d}'.format(0)
      s2 += '{:>10d}'.format(0) + "\n"
    if pyr5 or etype == 116 or etype == 118 or etype == 113: 
      s2 += elem10(ed,etype)
    else:
      i = 0  
      for en in mw.nodes(ed):
        s2 += '{:>10}'.format(en)
        i += 1
        if i % 8 == 0: s2 += "\n"
      if i % 8 <> 0:
        s2 += "\n"

  s2 += "    -1" + "\n"  

  if len(solution.modes()) > 0:
#    loadid2 = len(solution.modes())
#    loadid3 = 2 * loadid2
#    loadid4 = 3 * loadid2
    s3 = modal()
    sm1 = "Modal"
  elif len(solution.time_steps()) > 0:
    s3 = dynamic()
    sm1 = "Daynamic"
  else: 
    if ck21: s3 = static()
    if ck22: s4 = static_stress()
    if ck23: s5 = static_strain()
    if ck24: s6 = resultants(24)
    sm1 = "Static"

  nd = len(solution.all_nodes())

  import os
  fs = os.path.basename(__file__)
  with open(filename,'w') as fs:
    if ndn > 0:
      if ndn == nn:
        s1 += "    -1" + "\n"
        fs.write(s1)
      else:
        s1 += s9 + "    -1" + "\n"
        fs.write(s1)
    edn = ed + edn
    if edn > 0: fs.write(s2)
    if s3 <> "":
        fs.write(s3)
        sm1 += " Shape"
    if s4 <> "":
        fs.write(s4)
        sm1 += ", Stress"
    if s5 <> "":
        fs.write(s5)
        sm1 += ", Strain"
    if s6 <> "":
        fs.write(s6)
        sm1 += ", Von Mises stress"
    fs.close

  sm = "Saved file : " + filename + "\n"
  sm = sm + "\n" + "Model"
  sm = sm + "\n" + "Output Nodes : " + str(ndn) + "    Elements : " + str(edn) + "\n"
  if nd > 0:
    sm = sm + "Solutions" + "\n"
    sm = sm + sm1 + " data ..." + "\n"
  sm = sm + "\n" + "Elapsed time : " + str(time.clock() - start) + " sec"
  mw.message(sm)
#

def elem10(ed,etype):
#  mw.message("elem10")
  global edn, ndn, s9
  if ck6:
    ex = solution.nodes(ed)
    ee = len(solution.nodes(ed))
  else:
    ex = mw.nodes(ed)
    ee = len(mw.nodes(ed))
  if etype == 111:
      sx = '{:>10}'.format(ex[0])
      sx += '{:>10}'.format(ex[1])
      sx += '{:>10}'.format(ex[3])
      sx += '{:>10}'.format(ex[4]) + "\n"
      edn += 1
      sx += '{:>10d}'.format(ed+edn)
      sx += '{:>10d}'.format(etype)
      sx += '{:>10d}'.format(0)
      sx += '{:>10d}'.format(0)
      sx += '{:>10d}'.format(0)
      sx += '{:>10d}'.format(4) + "\n"
      sx += '{:>10}'.format(ex[1])
      sx += '{:>10}'.format(ex[2])
      sx += '{:>10}'.format(ex[3])
      sx += '{:>10}'.format(ex[4]) + "\n"
  elif etype == 116: 
      sx = '{:>10}'.format(ex[0])
      sx += '{:>10}'.format(ex[8])
      sx += '{:>10}'.format(ex[1])
      sx += '{:>10}'.format(ex[9])
      sx += '{:>10}'.format(ex[2])
      sx += '{:>10}'.format(ex[10])
      sx += '{:>10}'.format(ex[3])
      sx += '{:>10}'.format(ex[11]) + "\n"
      sx += '{:>10}'.format(ex[12])
      sx += '{:>10}'.format(ex[13])
      sx += '{:>10}'.format(ex[14])
      sx += '{:>10}'.format(ex[15])
      sx += '{:>10}'.format(ex[4])
      sx += '{:>10}'.format(ex[16])
      sx += '{:>10}'.format(ex[5])
      sx += '{:>10}'.format(ex[17]) + "\n"
      sx += '{:>10}'.format(ex[6])
      sx += '{:>10}'.format(ex[18])
      sx += '{:>10}'.format(ex[7])
      sx += '{:>10}'.format(ex[19]) + "\n"
  elif etype == 118 and ee > 10:
      nx = (mw.node(ex[3]).x - mw.node(ex[1]).x) / 2 + mw.node(ex[1]).x
      ny = (mw.node(ex[3]).y - mw.node(ex[1]).y) / 2 + mw.node(ex[1]).y
      nz = (mw.node(ex[3]).z - mw.node(ex[1]).z) / 2 + mw.node(ex[1]).z
      ndn += 1
      s9 = s9 + '{:>10d}'.format(ndn)
      s9 = s9 + '{:>10d}'.format(0)
      s9 = s9 + '{:>10d}'.format(0)
      s9 = s9 + '{:>10d}'.format(1) + "\n"
      s9 = s9 + '{:25.16E}'.format(nx) + '{:25.16E}'.format(ny) + '{:25.16E}'.format(nz) + "\n"
      sx = '{:>10}'.format(ex[0])
      sx += '{:>10}'.format(ex[5])
      sx += '{:>10}'.format(ex[1])
      sx += '{:>10}'.format(ndn)
      sx += '{:>10}'.format(ex[3])
      sx += '{:>10}'.format(ex[8])
      sx += '{:>10}'.format(ex[9])
      sx += '{:>10}'.format(ex[10]) + "\n"
      sx += '{:>10}'.format(ex[12])
      sx += '{:>10}'.format(ex[4]) + "\n"
      edn += 1
      sx += '{:>10d}'.format(ed+edn)
      sx += '{:>10d}'.format(etype)
      sx += '{:>10d}'.format(0)
      sx += '{:>10d}'.format(0)
      sx += '{:>10d}'.format(0)
      sx += '{:>10d}'.format(10) + "\n"
      sx += '{:>10}'.format(ex[2])
      sx += '{:>10}'.format(ex[7])
      sx += '{:>10}'.format(ex[3])
      sx += '{:>10}'.format(ndn)
      sx += '{:>10}'.format(ex[1])
      sx += '{:>10}'.format(ex[6])
      sx += '{:>10}'.format(ex[11])
      sx += '{:>10}'.format(ex[12]) + "\n"
      sx += '{:>10}'.format(ex[10])
      sx += '{:>10}'.format(ex[4]) + "\n"
  elif etype == 118:
      sx = '{:>10}'.format(ex[0])
      sx += '{:>10}'.format(ex[4])
      sx += '{:>10}'.format(ex[1])
      sx += '{:>10}'.format(ex[5])
      sx += '{:>10}'.format(ex[2])
      sx += '{:>10}'.format(ex[6])
      sx += '{:>10}'.format(ex[7])
      sx += '{:>10}'.format(ex[8]) + "\n"
      sx += '{:>10}'.format(ex[9])
      sx += '{:>10}'.format(ex[3]) + "\n"
  elif etype == 113: 
      sx = '{:>10}'.format(ex[0])
      sx += '{:>10}'.format(ex[6])
      sx += '{:>10}'.format(ex[1])
      sx += '{:>10}'.format(ex[7])
      sx += '{:>10}'.format(ex[2])
      sx += '{:>10}'.format(ex[8])
      sx += '{:>10}'.format(ex[9])
      sx += '{:>10}'.format(ex[10]) + "\n"
      sx += '{:>10}'.format(ex[11])
      sx += '{:>10}'.format(ex[3])
      sx += '{:>10}'.format(ex[12])
      sx += '{:>10}'.format(ex[4])
      sx += '{:>10}'.format(ex[13])
      sx += '{:>10}'.format(ex[5])
      sx += '{:>10}'.format(ex[14]) + "\n"

  return sx

#
def static():
#  mw.message("static")
  global loadid,loadid2,loadid3,loadid4
  s3 = "" 
  try:
    xx = '{:>13.5E}'.format(solution.node_value("displx", 1))
  except: return s3
  s3 = "    -1" + "\n" + "  2414" + "\n"
  s3 += '{:>10d}'.format(1) + "\n"
  s3 += "STATIC SHAPE" + "\n"
  s3 += '{:>10d}'.format(1) + "\n" # Dataset location
  for i in range(5):
    s3 += "NONE" + "\n"

  try:
      rx = '{:>13.5E}'.format(solution.node_value("rotx", 1))
      dofc = 3
      dofs = 6
  except:
      dofc = 2
      dofs = 3
  loadid += 1

  s3 += '{:>10d}'.format(1) + '{:>10d}'.format(1) + '{:>10d}'.format(dofc)
  s3 += '{:>10d}'.format(8) + '{:>10d}'.format(2) + '{:>10d}'.format(dofs) + "\n"
  s3 += '{:>10d}'.format(-11) + '{:>10d}'.format(0) + '{:>10d}'.format(1) + '{:>10d}'.format(0)
  s3 += '{:>10d}'.format(loadid) + '{:>10d}'.format(1) + '{:>10d}'.format(0) + '{:>10d}'.format(0)+ "\n"
  s3 += '{:>10d}'.format(1500) + '{:>10d}'.format(0) + "\n"
  try:
    frq = '{:>13.5E}'.format(solution.frequency(1))
  except: frq = '{:>13.5E}'.format(0.0)
  s3 += '{:>13.5E}'.format(0.0) + frq + '{:>13.5E}'.format(0.0) 
  s3 += '{:>13.5E}'.format(0.0) + '{:>13.5E}'.format(0.0) + '{:>13.5E}'.format(0.0) + "\n"
  s3 += '{:>13.5E}'.format(0.0) + '{:>13.5E}'.format(0.0) + '{:>13.5E}'.format(0.0)
  s3 += '{:>13.5E}'.format(0.0) + '{:>13.5E}'.format(0.0) + '{:>13.5E}'.format(0.0) + "\n"

  for nd in solution.all_nodes():
    # Read displacement from solution
    s3 += '{:>10d}'.format(nd) + "\n"
    s3 += '{:>13.5E}'.format(solution.node_value("displx", nd))
    s3 += '{:>13.5E}'.format(solution.node_value("disply", nd))
    try:
      s3 += '{:>13.5E}'.format(solution.node_value("displz", nd))
    except:
      s3 += '{:>13.5E}'.format(0.0)

    if dofs == 6:
      s3 += '{:>13.5E}'.format(solution.node_value("rotx", nd))
      s3 += '{:>13.5E}'.format(solution.node_value("roty", nd))
      try:
        s3 += '{:>13.5E}'.format(solution.node_value("rotz", nd))
      except:
        s3 += '{:>13.5E}'.format(0.0)

    s3 += "\n"

  s3 += "    -1" + "\n"
  return s3

#
def static_stress():
#  mw.message("static_stress")
  global s4,loadid,loadid2,loadid3,loadid4
#  s4 = ""
  try:
    xx = '{:>13.5E}'.format(solution.node_value("stressxx", 1))
  except: return s4

  s4 = "    -1" + "\n" + "  2414" + "\n"
  s4 += '{:>10d}'.format(1) + "\n"
  s4 += "STATIC STRESS" + "\n"
  s4 += '{:>10d}'.format(1) + "\n" # Dataset location
  for i in range(5):
    s4 += "NONE" + "\n"

  try:
      xy = '{:>13.5E}'.format(solution.node_value("stressxy", 1))
      dofc = 3
      dofs = 6
  except:
      dofc = 2
      dofs = 3
  loadid2 += 1

  s4 += '{:>10d}'.format(1) + '{:>10d}'.format(1) + '{:>10d}'.format(dofc)
  s4 += '{:>10d}'.format(2) + '{:>10d}'.format(2) + '{:>10d}'.format(dofs) + "\n"
  s4 += '{:>10d}'.format(-11) + '{:>10d}'.format(0) + '{:>10d}'.format(1) + '{:>10d}'.format(0)
  s4 += '{:>10d}'.format(loadid2) + '{:>10d}'.format(1) + '{:>10d}'.format(0) + '{:>10d}'.format(0)+ "\n"
  s4 += '{:>10d}'.format(1500) + '{:>10d}'.format(0) + "\n"
  try:
    frq = '{:>13.5E}'.format(solution.frequency(1))
  except: frq = '{:>13.5E}'.format(0.0)
  s4 += '{:>13.5E}'.format(0.0) + frq + '{:>13.5E}'.format(0.0) 
  s4 += '{:>13.5E}'.format(0.0) + '{:>13.5E}'.format(0.0) + '{:>13.5E}'.format(0.0) + "\n"
  s4 += '{:>13.5E}'.format(0.0) + '{:>13.5E}'.format(0.0) + '{:>13.5E}'.format(0.0)
  s4 += '{:>13.5E}'.format(0.0) + '{:>13.5E}'.format(0.0) + '{:>13.5E}'.format(0.0) + "\n"

  for nd in solution.all_nodes():
    # Read displacement from solution
    s4 += '{:>10d}'.format(nd) + "\n"
    s4 += '{:>13.5E}'.format(solution.node_value("stressxx", nd))
    s4 += '{:>13.5E}'.format(solution.node_value("stressyy", nd))
    try:
      s4 += '{:>13.5E}'.format(solution.node_value("stresszz", nd))
    except:
      s4 += '{:>13.5E}'.format(0.0)

    if dofs == 6:
      s4 += '{:>13.5E}'.format(solution.node_value("stressxy", nd))
      s4 += '{:>13.5E}'.format(solution.node_value("stressyz", nd))
      try:
        s4 += '{:>13.5E}'.format(solution.node_value("stresszx", nd))
      except:
        s4 += '{:>13.5E}'.format(0.)

    s4 += "\n"

  s4 += "    -1" + "\n"
  return s4

#
def static_strain():
#  mw.message("static_strain")
  global loadid,loadid2,loadid3,loadid4
  s5 = "" 
  try:
    xx = '{:>13.5E}'.format(solution.node_value("strainxx", 2))
  except: return s5
 
  s5 = "    -1" + "\n" + "  2414" + "\n"
  s5 += '{:>10d}'.format(1) + "\n"
  s5 += "STATIC STRAIN" + "\n"
  s5 += '{:>10d}'.format(1) + "\n" # Dataset location
  for i in range(5):
    s5 += "NONE" + "\n"

  try:
      xy = '{:>13.5E}'.format(solution.node_value("strainxy", 1))
      dofc = 3
      dofs = 6 
  except:
      dofc = 2
      dofs = 3
  loadid3 += 1

  s5 += '{:>10d}'.format(1) + '{:>10d}'.format(1) + '{:>10d}'.format(dofc)
  s5 += '{:>10d}'.format(3) + '{:>10d}'.format(2) + '{:>10d}'.format(dofs) + "\n"
  s5 += '{:>10d}'.format(-11) + '{:>10d}'.format(0) + '{:>10d}'.format(1) + '{:>10d}'.format(0)
  s5 += '{:>10d}'.format(loadid3) + '{:>10d}'.format(1) + '{:>10d}'.format(0) + '{:>10d}'.format(0)+ "\n"
  s5 += '{:>10d}'.format(1500) + '{:>10d}'.format(0) + "\n"
  try:
    frq = '{:>13.5E}'.format(solution.frequency(1))
  except: frq = '{:>13.5E}'.format(0.0)
  s5 += '{:>13.5E}'.format(0.0) + frq + '{:>13.5E}'.format(0.0) 
  s5 += '{:>13.5E}'.format(0.0) + '{:>13.5E}'.format(0.0) + '{:>13.5E}'.format(0.0) + "\n"
  s5 += '{:>13.5E}'.format(0.0) + '{:>13.5E}'.format(0.0) + '{:>13.5E}'.format(0.0)
  s5 += '{:>13.5E}'.format(0.0) + '{:>13.5E}'.format(0.0) + '{:>13.5E}'.format(0.0) + "\n"

  for nd in solution.all_nodes():
    # Read displacement from solution
    s5 += '{:>10d}'.format(nd) + "\n"
    s5 += '{:>13.5E}'.format(solution.node_value("strainxx", nd))
    s5 += '{:>13.5E}'.format(solution.node_value("strainyy", nd))
    try:
      s5 += '{:>13.5E}'.format(solution.node_value("strainzz", nd))
    except:
      s5 += '{:>13.5E}'.format(0.0)

    if dofs == 6:
      s5 += '{:>13.5E}'.format(solution.node_value("strainxy", nd))
      s5 += '{:>13.5E}'.format(solution.node_value("strainyz", nd))
      try:
        s5 += '{:>13.5E}'.format(solution.node_value("strainzx", nd))
      except:
        s5 += '{:>13.5E}'.format(0.)

    s5 += "\n"

  s5 += "    -1" + "\n"
  return s5

#
def static_stressm(mn):
#  mw.message("static_stress")
  global s4,loadid,loadid2,loadid3,loadid4
#  s4 = ""
  try:
    xx = '{:>13.5E}'.format(solution.node_value("stressxx", 1,mode=mn))
  except: return s4

  s4 += "    -1" + "\n" + "  2414" + "\n"
  s4 += '{:>10d}'.format(mn) + "\n"
  s4 += "STATIC STRESS" + "\n"
  s4 += '{:>10d}'.format(1) + "\n" # Dataset location
  for i in range(5):
    s4 += "NONE" + "\n"

  try:
      xy = '{:>13.5E}'.format(solution.node_value("stressxy", 1,mode=mn))
      dofc = 3
      dofs = 6
  except:
      dofc = 2
      dofs = 3
  loadid2 += 1

  s4 += '{:>10d}'.format(1) + '{:>10d}'.format(1) + '{:>10d}'.format(dofc)
  s4 += '{:>10d}'.format(2) + '{:>10d}'.format(2) + '{:>10d}'.format(dofs) + "\n"
  s4 += '{:>10d}'.format(-11) + '{:>10d}'.format(0) + '{:>10d}'.format(1) + '{:>10d}'.format(0)
  s4 += '{:>10d}'.format(loadid2) + '{:>10d}'.format(mn) + '{:>10d}'.format(0) + '{:>10d}'.format(0)+ "\n"
  s4 += '{:>10d}'.format(1500) + '{:>10d}'.format(0) + "\n"
  try:
    frq = '{:>13.5E}'.format(solution.frequency(mn))
  except: frq = '{:>13.5E}'.format(0.0)
  s4 += '{:>13.5E}'.format(0.0) + frq + '{:>13.5E}'.format(0.0) 
  s4 += '{:>13.5E}'.format(0.0) + '{:>13.5E}'.format(0.0) + '{:>13.5E}'.format(0.0) + "\n"
  s4 += '{:>13.5E}'.format(0.0) + '{:>13.5E}'.format(0.0) + '{:>13.5E}'.format(0.0)
  s4 += '{:>13.5E}'.format(0.0) + '{:>13.5E}'.format(0.0) + '{:>13.5E}'.format(0.0) + "\n"

  for nd in solution.all_nodes():
    # Read displacement from solution
    s4 += '{:>10d}'.format(nd) + "\n"
    s4 += '{:>13.5E}'.format(solution.node_value("stressxx", nd,mode=mn))
    s4 += '{:>13.5E}'.format(solution.node_value("stressyy", nd,mode=mn))
    try:
      s4 += '{:>13.5E}'.format(solution.node_value("stresszz", nd,mode=mn))
    except:
      s4 += '{:>13.5E}'.format(0.0)

    if dofs == 6:
      s4 += '{:>13.5E}'.format(solution.node_value("stressxy", nd,mode=mn))
      s4 += '{:>13.5E}'.format(solution.node_value("stressyz", nd,mode=mn))
      try:
        s4 += '{:>13.5E}'.format(solution.node_value("stresszx", nd,mode=mn))
      except:
        s4 += '{:>13.5E}'.format(0.)

    s4 += "\n"

  s4 += "    -1" + "\n"
  return s4

#
def static_stresst(mn):
#  mw.message("static_stress")
  global s4,loadid,loadid2,loadid3,loadid4
#  s4 = ""
  try:
    xx = '{:>13.5E}'.format(solution.node_value("stressxx", 1, time_step=mn))
  except: return s4

  s4 += "    -1" + "\n" + "  2414" + "\n"
  s4 += '{:>10d}'.format(mn) + "\n"
  s4 += "STATIC STRESS" + "\n"
  s4 += '{:>10d}'.format(1) + "\n" # Dataset location
  for i in range(5):
    s4 += "NONE" + "\n"

  try:
      xy = '{:>13.5E}'.format(solution.node_value("stressxy", 1, time_step=mn))
      dofc = 3
      dofs = 6
  except:
      dofc = 2
      dofs = 3
  loadid2 += 1

  s4 += '{:>10d}'.format(1) + '{:>10d}'.format(1) + '{:>10d}'.format(dofc)
  s4 += '{:>10d}'.format(2) + '{:>10d}'.format(2) + '{:>10d}'.format(dofs) + "\n"
  s4 += '{:>10d}'.format(-11) + '{:>10d}'.format(0) + '{:>10d}'.format(1) + '{:>10d}'.format(0)
  s4 += '{:>10d}'.format(loadid2) + '{:>10d}'.format(mn) + '{:>10d}'.format(0) + '{:>10d}'.format(0)+ "\n"
  s4 += '{:>10d}'.format(1500) + '{:>10d}'.format(0) + "\n"
  try:
    frq = '{:>13.5E}'.format(solution.time(mn))
  except: frq = '{:>13.5E}'.format(0.0)
  s4 += '{:>13.5E}'.format(0.0) + frq + '{:>13.5E}'.format(0.0) 
  s4 += '{:>13.5E}'.format(0.0) + '{:>13.5E}'.format(0.0) + '{:>13.5E}'.format(0.0) + "\n"
  s4 += '{:>13.5E}'.format(0.0) + '{:>13.5E}'.format(0.0) + '{:>13.5E}'.format(0.0)
  s4 += '{:>13.5E}'.format(0.0) + '{:>13.5E}'.format(0.0) + '{:>13.5E}'.format(0.0) + "\n"

  for nd in solution.all_nodes():
    # Read displacement from solution
    s4 += '{:>10d}'.format(nd) + "\n"
    s4 += '{:>13.5E}'.format(solution.node_value("stressxx", nd,time_step=mn))
    s4 += '{:>13.5E}'.format(solution.node_value("stressyy", nd,time_step=mn))
    try:
      s4 += '{:>13.5E}'.format(solution.node_value("stresszz", nd,time_step=mn))
    except:
      s4 += '{:>13.5E}'.format(0.0)

    if dofs == 6:
      s4 += '{:>13.5E}'.format(solution.node_value("stressxy", nd,time_step=mn))
      s4 += '{:>13.5E}'.format(solution.node_value("stressyz", nd,time_step=mn))
      try:
        s4 += '{:>13.5E}'.format(solution.node_value("stresszx", nd,time_step=mn))
      except:
        s4 += '{:>13.5E}'.format(0.)

    s4 += "\n"

  s4 += "    -1" + "\n"
  return s4

#
def modal():
#  mw.message("MODAL")
  global ck22,ck24,s4,s6,loadid,loadid2,loadid3,loadid4
  s3 = ""
  for mn in solution.modes():
    s3 += "    -1" + "\n" + "  2414" + "\n"
    s3 += '{:>10d}'.format(mn) + "\n"
    try:
      rx = '{:>13.5E}'.format(solution.node_value("pressure", 1, mode=1))
      dofc = 2
      dofs = 3
      atype = 1
      sctype = 9
      ss = "PRESSURE"
      loadid4 += 1
    except:
      atype = 2
      sctype = 8
      ss = "MODE SHAPES"
      loadid4 = mn
      try:
        rx = '{:>13.5E}'.format(solution.node_value("rotx", 1, mode=1))
        dofc = 3
        dofs = 6 
      except: 
        dofc = 2
        dofs = 3

    s3 += ss + "\n"
    s3 += '{:>10d}'.format(1) + "\n" # Dataset location

    for i in range(5):
      s3 += "NONE" + "\n"

    s3 += '{:>10d}'.format(1) + '{:>10d}'.format(atype) + '{:>10d}'.format(dofc)
    s3 += '{:>10d}'.format(sctype) + '{:>10d}'.format(2) + '{:>10d}'.format(dofs) + "\n"
    s3 += '{:>10d}'.format(-11) + '{:>10d}'.format(0) + '{:>10d}'.format(1) + '{:>10d}'.format(0)
    s3 += '{:>10d}'.format(loadid4) + '{:>10d}'.format(mn) + '{:>10d}'.format(0) + '{:>10d}'.format(0) + "\n"
    s3 += '{:>10d}'.format(1500) + '{:>10d}'.format(0) + "\n"
    try:
      frq = '{:>13.5E}'.format(solution.frequency(mn))
    except: frq = '{:>13.5E}'.format(0.0)
    s3 += '{:>13.5E}'.format(0.0) + frq + '{:>13.5E}'.format(0.0) 
    s3 += '{:>13.5E}'.format(0.0) + '{:>13.5E}'.format(0.0) + '{:>13.5E}'.format(0.0) + "\n"
    s3 += '{:>13.5E}'.format(0.0) + '{:>13.5E}'.format(0.0) + '{:>13.5E}'.format(0.0)
    s3 += '{:>13.5E}'.format(0.0) + '{:>13.5E}'.format(0.0) + '{:>13.5E}'.format(0.0) + "\n"

    if sctype == 9:
      for nd in solution.all_nodes():
        # Read pressure from solution
        s3 += '{:>10d}'.format(nd) + "\n"
        s3 += '{:>13.5E}'.format(solution.node_value("pressure", nd, mode=mn))
        s3 += '{:>13.5E}'.format(0.0) + '{:>13.5E}'.format(0.0) + "\n"
    else:
      for nd in solution.all_nodes():
        # Read displacement from solution
        s3 += '{:>10d}'.format(nd) + "\n"
        s3 += '{:>13.5E}'.format(solution.node_value("displx", nd, mode=mn))
        s3 += '{:>13.5E}'.format(solution.node_value("disply", nd, mode=mn))
        try:
          s3 += '{:>13.5E}'.format(solution.node_value("displz", nd, mode=mn))
        except: s3 += '{:>13.5E}'.format(0.0)
        if dofs == 6:
          s3 += '{:>13.5E}'.format(solution.node_value("rotx", nd, mode=mn))
          s3 += '{:>13.5E}'.format(solution.node_value("roty", nd, mode=mn))
          try:
            s3 += '{:>13.5E}'.format(solution.node_value("rotz", nd, mode=mn))
          except: s3 += '{:>13.5E}'.format(0.0)

        s3 += "\n"

      if ck22: s4 = static_stressm(mn)
      if ck24: s6 = resultantsm(24,mn)

    s3 += "    -1" + "\n"

  return s3

#
def dynamic():
#  mw.message("DYNAMIC")
  global ck22,ck24,s4,s5,s6,loadid,loadid2,loadid3,loadid4
  s3 = ""
  for tn in solution.time_steps():
    s3 += "    -1" + "\n" + "  2414" + "\n"
    s3 += '{:>10d}'.format(tn) + "\n"
    try:
      rx = '{:>13.5E}'.format(solution.node_value("pressure", 1, time_step=1))
      dofc = 2
      dofs = 3
      atype = 1
      sctype = 9
      ss = "PRESSURE"
      loadid4 += 1
    except:
      try:
        rx = '{:>13.5E}'.format(solution.node_value("temperature", 1, time_step=1))
        dofc = 2
        dofs = 3
        atype = 1
        sctype = 5
        ss = "TEMPERATURE"
        loadid4 += 1
      except:
        atype = 1
        sctype = 8
        ss = "DYNAMIC SHAPES" 
        try:
          rx = '{:>13.5E}'.format(solution.node_value("rotx", 1, time_step=1))
          dofc = 3
          dofs = 6 
        except: 
          dofc = 2
          dofs = 3
        loadid += 1

    s3 += ss + "\n"
    s3 += '{:>10d}'.format(1) + "\n" # Dataset location

    for i in range(5):
      s3 += "NONE" + "\n"

    s3 += '{:>10d}'.format(1) + '{:>10d}'.format(atype) + '{:>10d}'.format(dofc)
    s3 += '{:>10d}'.format(sctype) + '{:>10d}'.format(2) + '{:>10d}'.format(dofs) + "\n"
    s3 += '{:>10d}'.format(-11) + '{:>10d}'.format(0) + '{:>10d}'.format(1) + '{:>10d}'.format(0)
    if sctype == 8:
      s3 += '{:>10d}'.format(loadid) + '{:>10d}'.format(tn) + '{:>10d}'.format(0) + '{:>10d}'.format(0) + "\n"
    else:
      s3 += '{:>10d}'.format(loadid4) + '{:>10d}'.format(tn) + '{:>10d}'.format(0) + '{:>10d}'.format(0) + "\n"
    s3 += '{:>10d}'.format(1500) + '{:>10d}'.format(0) + "\n"
    try:
      frq = '{:>13.5E}'.format(solution.frequency(tn))
    except: frq = '{:>13.5E}'.format(0.0)
    s3 += '{:>13.5E}'.format(0.0) + frq + '{:>13.5E}'.format(0.0) 
    s3 += '{:>13.5E}'.format(0.0) + '{:>13.5E}'.format(0.0) + '{:>13.5E}'.format(0.0) + "\n"
    s3 += '{:>13.5E}'.format(0.0) + '{:>13.5E}'.format(0.0) + '{:>13.5E}'.format(0.0)
    s3 += '{:>13.5E}'.format(0.0) + '{:>13.5E}'.format(0.0) + '{:>13.5E}'.format(0.0) + "\n"

    if sctype == 9:
      for nd in solution.all_nodes():
        # Read pressure from solution
        s3 += '{:>10d}'.format(nd) + "\n"
        s3 += '{:>13.5E}'.format(solution.node_value("pressure", nd, time_step=tn))
        s3 += '{:>13.5E}'.format(0.0) + '{:>13.5E}'.format(0.0) + "\n"
    elif sctype == 5:
      for nd in solution.all_nodes():
        # Read temperature from solution
        s3 += '{:>10d}'.format(nd) + "\n"
        s3 += '{:>13.5E}'.format(solution.node_value("temperature", nd, time_step=tn))
        s3 += '{:>13.5E}'.format(0.0) + '{:>13.5E}'.format(0.0) + "\n"
    else:
      for nd in solution.all_nodes():
        # Read displacement from solution
        s3 += '{:>10d}'.format(nd) + "\n"
        s3 += '{:>13.5E}'.format(solution.node_value("displx", nd, time_step=tn))
        s3 += '{:>13.5E}'.format(solution.node_value("disply", nd, time_step=tn))
        try:
          s3 += '{:>13.5E}'.format(solution.node_value("displz", nd, time_step=tn))
        except: s3 += '{:>13.5E}'.format(0.0)
        if dofs == 6:
          s3 += '{:>13.5E}'.format(solution.node_value("rotx", nd, time_step=tn))
          s3 += '{:>13.5E}'.format(solution.node_value("roty", nd, time_step=tn))
          try:
            s3 += '{:>13.5E}'.format(solution.node_value("rotz", nd, time_step=tn))
          except: s3 += '{:>13.5E}'.format(0.0)
        s3 += "\n"

    if ck22: s4 = static_stresst(tn)
    if ck24: s6 = resultantst(24,tn)

    s3 += "    -1" + "\n"

  return s3

#
def resultants(cc):
  global s6,loadid,loadid2,loadid3,loadid4
#  mw.message("resultants")
#  s6 = ""
  if cc == 24:
    sctype = 2
    sc = "vonmises" # "vonmises" or "vonmisesu" "vonmisesm" "vonmisesb"
    try:
      xx = '{:>13.5E}'.format(solution.node_value(sc, 1))
    except:
      sc = "vonmisesb"
      try:
        xx = '{:>13.5E}'.format(solution.node_value(sc, 1))
      except: return s6

  else: return s6

  s6 += "    -1" + "\n" + "  2414" + "\n"
  s6 += '{:>10d}'.format(1) + "\n"
  s6 += sc.upper() + "\n"
  s6 += '{:>10d}'.format(1) + "\n" # Dataset location
  for i in range(5):
    s6 += "NONE" + "\n"

  dofc = 2
  dofs = 3
  loadid4 += 1

  s6 += '{:>10d}'.format(1) + '{:>10d}'.format(1) + '{:>10d}'.format(dofc)
  s6 += '{:>10d}'.format(sctype) + '{:>10d}'.format(2) + '{:>10d}'.format(dofs) + "\n"
  s6 += '{:>10d}'.format(-11) + '{:>10d}'.format(0) + '{:>10d}'.format(1) + '{:>10d}'.format(0)
  s6 += '{:>10d}'.format(loadid4) + '{:>10d}'.format(1) + '{:>10d}'.format(0) + '{:>10d}'.format(0)+ "\n"
  s6 += '{:>10d}'.format(1500) + '{:>10d}'.format(0) + "\n"
  try:
    frq = '{:>13.5E}'.format(solution.frequency(1))
  except: frq = '{:>13.5E}'.format(0.0)
  s6 += '{:>13.5E}'.format(0.0) + frq + '{:>13.5E}'.format(0.0) 
  s6 += '{:>13.5E}'.format(0.0) + '{:>13.5E}'.format(0.0) + '{:>13.5E}'.format(0.0) + "\n"
  s6 += '{:>13.5E}'.format(0.0) + '{:>13.5E}'.format(0.0) + '{:>13.5E}'.format(0.0)
  s6 += '{:>13.5E}'.format(0.0) + '{:>13.5E}'.format(0.0) + '{:>13.5E}'.format(0.0) + "\n"

  for nd in solution.all_nodes():
    # Read displacement from solution
    s6 += '{:>10d}'.format(nd) + "\n"
    s6 += '{:>13.5E}'.format(solution.node_value(sc, nd))
    s6 += '{:>13.5E}'.format(0.0) + '{:>13.5E}'.format(0.0) + "\n"

  s6 += "    -1" + "\n"
  return s6

#
def resultantsm(cc,mn):
  global s6,loadid,loadid2,loadid3,loadid4
#  mw.message("resultants")
#  s6 = ""
  if cc == 24:
    sctype = 2
    sc = "vonmises" # "vonmises" or "vonmisesu" "vonmisesm" "vonmisesb"
    try:
      xx = '{:>13.5E}'.format(solution.node_value(sc, 1, mode=mn))
    except:
      sc = "vonmisesb"
      try:
        xx = '{:>13.5E}'.format(solution.node_value(sc, 1, mode=mn))
      except: return s6
  else: return s6
   
  s6 += "    -1" + "\n" + "  2414" + "\n"
  s6 += '{:>10d}'.format(mn) + "\n"
  s6 += sc.upper() + "\n"
  s6 += '{:>10d}'.format(1) + "\n" # Dataset location
  for i in range(5):
    s6 += "NONE" + "\n"

  dofc = 2
  dofs = 3
  loadid4 = mn

  s6 += '{:>10d}'.format(1) + '{:>10d}'.format(1) + '{:>10d}'.format(dofc)
  s6 += '{:>10d}'.format(sctype) + '{:>10d}'.format(2) + '{:>10d}'.format(dofs) + "\n"
  s6 += '{:>10d}'.format(-11) + '{:>10d}'.format(0) + '{:>10d}'.format(1) + '{:>10d}'.format(0)
  s6 += '{:>10d}'.format(loadid4) + '{:>10d}'.format(mn) + '{:>10d}'.format(0) + '{:>10d}'.format(0)+ "\n"
  s6 += '{:>10d}'.format(1500) + '{:>10d}'.format(0) + "\n"
  try:
    frq = '{:>13.5E}'.format(solution.frequency(mn))
  except: frq = '{:>13.5E}'.format(0.0)
  s6 += '{:>13.5E}'.format(0.0) + frq + '{:>13.5E}'.format(0.0) 
  s6 += '{:>13.5E}'.format(0.0) + '{:>13.5E}'.format(0.0) + '{:>13.5E}'.format(0.0) + "\n"
  s6 += '{:>13.5E}'.format(0.0) + '{:>13.5E}'.format(0.0) + '{:>13.5E}'.format(0.0)
  s6 += '{:>13.5E}'.format(0.0) + '{:>13.5E}'.format(0.0) + '{:>13.5E}'.format(0.0) + "\n"

  for nd in solution.all_nodes():
    # Read displacement from solution
    s6 += '{:>10d}'.format(nd) + "\n"
    s6 += '{:>13.5E}'.format(solution.node_value(sc, nd, mode=mn))
    s6 += '{:>13.5E}'.format(0.0) + '{:>13.5E}'.format(0.0) + "\n"

  s6 += "    -1" + "\n"
  return s6

#
def resultantst(cc,mn):
  global s6,loadid,loadid2,loadid3,loadid4
#  mw.message("resultantst")
#  s6 = ""
  if cc == 24:
    sctype = 2
    sc = "vonmises" # "vonmises" or "vonmisesu" "vonmisesm" "vonmisesb"
    try:
      xx = '{:>13.5E}'.format(solution.node_value(sc, 1, time_step=mn))
    except:
      sc = "vonmisesb"
      try:
        xx = '{:>13.5E}'.format(solution.node_value(sc, 1, time_step=mn))
      except: return s6

  else: return s6

  s6 += "    -1" + "\n" + "  2414" + "\n"
  s6 += '{:>10d}'.format(mn) + "\n"
  s6 += sc.upper() + "\n"
  s6 += '{:>10d}'.format(1) + "\n" # Dataset location
  for i in range(5):
    s6 += "NONE" + "\n"

  dofc = 2
  dofs = 3
  loadid4 = mn

  s6 += '{:>10d}'.format(1) + '{:>10d}'.format(1) + '{:>10d}'.format(dofc)
  s6 += '{:>10d}'.format(sctype) + '{:>10d}'.format(2) + '{:>10d}'.format(dofs) + "\n"
  s6 += '{:>10d}'.format(-11) + '{:>10d}'.format(0) + '{:>10d}'.format(1) + '{:>10d}'.format(0)
  s6 += '{:>10d}'.format(loadid4) + '{:>10d}'.format(mn) + '{:>10d}'.format(0) + '{:>10d}'.format(0)+ "\n"
  s6 += '{:>10d}'.format(1500) + '{:>10d}'.format(0) + "\n"
  try:
    frq = '{:>13.5E}'.format(solution.time(mn))
  except: frq = '{:>13.5E}'.format(0.0)
  s6 += '{:>13.5E}'.format(0.0) + frq + '{:>13.5E}'.format(0.0) 
  s6 += '{:>13.5E}'.format(0.0) + '{:>13.5E}'.format(0.0) + '{:>13.5E}'.format(0.0) + "\n"
  s6 += '{:>13.5E}'.format(0.0) + '{:>13.5E}'.format(0.0) + '{:>13.5E}'.format(0.0)
  s6 += '{:>13.5E}'.format(0.0) + '{:>13.5E}'.format(0.0) + '{:>13.5E}'.format(0.0) + "\n"

  for nd in solution.all_nodes():
    # Read displacement from solution
    s6 += '{:>10d}'.format(nd) + "\n"
    s6 += '{:>13.5E}'.format(solution.node_value(sc, nd, time_step=mn))
    s6 += '{:>13.5E}'.format(0.0) + '{:>13.5E}'.format(0.0) + "\n"

  s6 += "    -1" + "\n"
  return s6

#
f = IForm()
Form.ShowDialog(f)

